<template>
    <form @submit.prevent="onSubmit" class="space-y-4">
        <div class="form-control">
            <label class="flex flex-col" for="name">
                <div>Họ tên <span class="text-red-500">*</span></div>
                <input
                    v-model="data.name"
                    id="name"
                    type="text"
                    class="focus:border-main-color rounded-md border border-gray-200 mt-1 px-3 py-2"
                    :class="{ 'border-red-400': dataErrors.name }"
                />
            </label>
            <div
                v-if="dataErrors.name"
                class="text-left text-sm text-red-500 mt-1"
            >
                {{ dataErrors.name }}
            </div>
        </div>

        <div class="form-control">
            <label class="flex flex-col" for="email">
                <div>Email <span class="text-red-500">*</span></div>
                <input
                    v-model="data.email"
                    id="email"
                    type="text"
                    class="focus:border-main-color rounded-md border border-gray-200 mt-1 px-3 py-2"
                    :class="{ 'border-red-400': dataErrors.email }"
                    placeholder="example@gmail.com"
                />
            </label>
            <div
                v-if="dataErrors.email"
                class="text-left text-sm text-red-500 mt-1"
            >
                {{ dataErrors.email }}
            </div>
        </div>

        <div class="form-control">
            <label class="flex flex-col" for="role">
                <div>Chức vụ <span class="text-red-500">*</span></div>
                <select
                    v-model="data.role"
                    id="role"
                    class="focus:border-main-color rounded-md border border-gray-200 mt-1 px-3 py-2"
                    :class="{ 'border-red-400': dataErrors.role }"
                >
                    <option disabled value="">Chọn chức vụ</option>
                    <option
                        :key="role.id"
                        v-for="role in SELECT_OPTION_ROLE"
                        :value="role.id"
                    >
                        {{ role.text }}
                    </option>
                </select>
            </label>
            <div
                v-if="dataErrors.role"
                class="text-left text-sm text-red-500 mt-1"
            >
                {{ dataErrors.role }}
            </div>
        </div>

        <div class="form-control">
            <label class="flex flex-col" for="password">
                <div>Mật khẩu <span class="text-red-500">*</span></div>
                <div class="relative">
                    <input
                        v-model="data.password"
                        id="password"
                        :type="isShowPassword ? 'text' : 'password'"
                        class="w-full rounded-md border focus:border-main-color border-gray-200 mt-1 px-3 py-2"
                        :class="{ 'border-red-400': dataErrors.password }"
                        placeholder="●●●●●●●●"
                    />
                    <div
                        @click="onToggleShowPassword('password')"
                        class="absolute top-1/2 right-2 transform -translate-y-1/2 z-10 cursor-pointer text-gray-500"
                    >
                        <Tooltip :text="isShowPassword ? 'Ẩn' : 'Hiện'">
                            <EyeIcon v-if="isShowPassword" />
                            <EyeOffIcon v-else />
                        </Tooltip>
                    </div>
                </div>
            </label>
            <div
                v-if="dataErrors.password"
                class="text-left text-sm text-red-500 mt-1"
            >
                {{ dataErrors.password }}
            </div>
        </div>

        <div class="form-control">
            <label class="flex flex-col" for="password_confirmation">
                <div>Nhập lại mật khẩu <span class="text-red-500">*</span></div>
                <div class="relative">
                    <input
                        v-model="data.password_confirmation"
                        id="password_confirmation"
                        :type="isShowpasswordConfirmation ? 'text' : 'password'"
                        class="w-full rounded-md border focus:border-main-color border-gray-200 mt-1 px-3 py-2"
                        :class="{
                            'border-red-400': dataErrors.password_confirmation
                        }"
                        placeholder="●●●●●●●●"
                    />
                    <div
                        @click="onToggleShowPassword('password_confirmation')"
                        class="absolute top-1/2 right-2 transform -translate-y-1/2 z-10 cursor-pointer text-gray-500"
                    >
                        <Tooltip
                            :text="isShowpasswordConfirmation ? 'Ẩn' : 'Hiện'"
                        >
                            <EyeIcon v-if="isShowpasswordConfirmation" />
                            <EyeOffIcon v-else />
                        </Tooltip>
                    </div>
                </div>
            </label>
            <div
                v-if="dataErrors.password_confirmation"
                class="text-left text-sm text-red-500 mt-1"
            >
                {{ dataErrors.password_confirmation }}
            </div>
        </div>

        <div class="form-control flex items-center gap-3">
            <BasicButton type="submit">Thêm</BasicButton>
            <LinkButton
                nameRoute="admin-user"
                classCustom="bg-color-danger hover:shadow-hover-danger"
            >
                Hủy
            </LinkButton>
        </div>
    </form>
</template>

<script>
import { reactive, ref, watch } from "vue";
import { useRouter } from "vue-router";
import { createToast } from "mosha-vue-toastify";

import useCreateUser from "@/hooks/user/useCreateUser";
import toolHelper from "@/helper/toolHelper";
import { SELECT_OPTION_ROLE } from "@/constants";

import { EyeIcon, EyeOffIcon } from "@heroicons/vue/outline";
import Tooltip from "@/components/tooltip/Tooltip.vue";
import BasicButton from "@/components/button/BasicButton.vue";
import LinkButton from "@/components/button/LinkButton.vue";

export default {
    components: {
        EyeIcon,
        EyeOffIcon,
        Tooltip,
        BasicButton,
        LinkButton
    },
    setup() {
        const data = reactive({
            name: "",
            email: "",
            password: "",
            password_confirmation: "",
            role: ""
        });

        const dataErrors = reactive({
            name: null,
            email: null,
            password: null,
            password_confirmation: null,
            role: null
        });

        const { errorResponse, onCreateUser } = useCreateUser();
        const router = useRouter();

        // watch password
        watch(
            () => data.password,
            newValue => {
                if (
                    newValue.length < 8 ||
                    newValue != data.password_confirmation
                ) {
                    if (newValue.length < 8) {
                        dataErrors.password =
                            "Mật khẩu phải chứa ít nhất 8 ký tự.";
                    } else {
                        dataErrors.password = null;
                    }

                    if (newValue != data.password_confirmation) {
                        dataErrors.password_confirmation =
                            "Mật khẩu không trùng khớp.";
                    } else {
                        dataErrors.password_confirmation = null;
                    }
                } else {
                    dataErrors.password = null;
                    dataErrors.password_confirmation = null;
                }
            }
        );
        // watch password_comfirmation
        watch(
            () => data.password_confirmation,
            newValue => {
                if (newValue != data.password) {
                    dataErrors.password_confirmation =
                        "Mật khẩu không trùng khớp.";
                } else {
                    dataErrors.password_confirmation = null;
                }
            }
        );

        // submit form
        async function onSubmit() {
            dataErrors.name = null;
            dataErrors.email = null;
            dataErrors.password = null;
            dataErrors.password_confirmation = null;
            dataErrors.role = null;

            let input_valid = true;
            // check empty input
            if (
                !data.name ||
                !data.email ||
                !data.password ||
                !data.password_confirmation ||
                data.role === ""
            ) {
                input_valid = false;
                if (!data.name) dataErrors.name = "Bạn chưa nhập họ tên";
                if (!data.email) dataErrors.email = "Bạn chưa nhập email";
                if (!data.password)
                    dataErrors.password = "Bạn chưa nhập mật khẩu";
                if (!data.password_confirmation)
                    dataErrors.password_confirmation =
                        "Bạn chưa nhập lại mật khẩu";
                if (data.role === "") dataErrors.role = "Bạn chưa chọn chức vụ";
            }

            // validate email
            if (!toolHelper.validateEmail(data.email)) {
                input_valid = false;
                dataErrors.email = "Email không đúng định dạng";
            }

            // check password
            if (data.password.length < 8) {
                input_valid = false;
                dataErrors.password = "Mật khẩu phải chứa ít nhất 8 ký tự";
            }
            if (data.password != data.password_confirmation) {
                input_valid = false;
                dataErrors.password_confirmation = "Mật khẩu không trùng khớp";
            }

            // check password_confirmation
            if (data.password_confirmation != data.password) {
                input_valid = false;
                dataErrors.password_confirmation = "Mật khẩu không trùng khớp";
            }

            // check input valid and submit form
            if (input_valid) {
                // show loading
                document.getElementById("full-page-loading").style.display =
                    "block";

                await onCreateUser(data);

                // hide loading
                document.getElementById("full-page-loading").style.display =
                    "none";

                // check error from server
                if (errorResponse.value) {
                    if (
                        errorResponse.value.name &&
                        errorResponse.value.name.length
                    ) {
                        dataErrors.name = "Bạn chưa nhập họ tên";
                    }
                    if (
                        errorResponse.value.email &&
                        errorResponse.value.email.length
                    ) {
                        dataErrors.email = errorResponse.value.email[0];
                    }
                    if (
                        errorResponse.value.password &&
                        errorResponse.value.password.length
                    ) {
                        dataErrors.password = errorResponse.value.password[0];
                    }
                    if (
                        errorResponse.value.password_confirmation &&
                        errorResponse.value.password_confirmation.length
                    ) {
                        dataErrors.password_confirmation =
                            errorResponse.value.password_confirmation[0];
                    }
                    if (
                        errorResponse.value.role &&
                        errorResponse.value.role.length
                    ) {
                        dataErrors.role = "Bạn chưa chọn chức vụ";
                    }
                } else {
                    router.push({ name: "admin-user", params: {} });
                    createToast("Thêm mới thành công", {
                        showIcon: true,
                        type: "success"
                    });
                }
            }
        }

        // show password
        const isShowPassword = ref(false);
        const isShowpasswordConfirmation = ref(false);
        function onToggleShowPassword(nameInput) {
            if (nameInput === "password")
                isShowPassword.value = !isShowPassword.value;
            else if (nameInput === "password_confirmation")
                isShowpasswordConfirmation.value = !isShowpasswordConfirmation.value;
        }

        return {
            SELECT_OPTION_ROLE,
            data,
            dataErrors,
            onSubmit,
            isShowPassword,
            isShowpasswordConfirmation,
            onToggleShowPassword
        };
    }
};
</script>
